INCLUDE(FindPkgConfig)
PKG_CHECK_MODULES(PC_HAMNET70 hamnet70)

FIND_PATH(
    HAMNET70_INCLUDE_DIRS
    NAMES hamnet70/api.h
    HINTS $ENV{HAMNET70_DIR}/include
        ${PC_HAMNET70_INCLUDEDIR}
    PATHS ${CMAKE_INSTALL_PREFIX}/include
          /usr/local/include
          /usr/include
)

FIND_LIBRARY(
    HAMNET70_LIBRARIES
    NAMES gnuradio-hamnet70
    HINTS $ENV{HAMNET70_DIR}/lib
        ${PC_HAMNET70_LIBDIR}
    PATHS ${CMAKE_INSTALL_PREFIX}/lib
          ${CMAKE_INSTALL_PREFIX}/lib64
          /usr/local/lib
          /usr/local/lib64
          /usr/lib
          /usr/lib64
          )

include("${CMAKE_CURRENT_LIST_DIR}/hamnet70Target.cmake")

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(HAMNET70 DEFAULT_MSG HAMNET70_LIBRARIES HAMNET70_INCLUDE_DIRS)
MARK_AS_ADVANCED(HAMNET70_LIBRARIES HAMNET70_INCLUDE_DIRS)
