/* -*- c++ -*- */
/* 
 * Copyright 2019 Thomas Kolb.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */


#ifndef INCLUDED_HAMNET70_CORRECT_FREQUENCY_FROM_PILOT_SYMS_H
#define INCLUDED_HAMNET70_CORRECT_FREQUENCY_FROM_PILOT_SYMS_H

#include <hamnet70/api.h>
#include <gnuradio/block.h>

namespace gr {
  namespace hamnet70 {

    /*!
     * \brief <+description of block+>
     * \ingroup hamnet70
     *
     */
    class HAMNET70_API correct_frequency_from_pilot_syms : virtual public gr::block
    {
     public:
      typedef boost::shared_ptr<correct_frequency_from_pilot_syms> sptr;

      /*!
       * \brief Return a shared_ptr to a new instance of hamnet70::correct_frequency_from_pilot_syms.
       *
       * To avoid accidental use of raw pointers, hamnet70::correct_frequency_from_pilot_syms's
       * constructor is in a private implementation
       * class. hamnet70::correct_frequency_from_pilot_syms::make is the public interface for
       * creating new instances.
       */
      static sptr make(const std::vector<gr_complex> &pilot_sequence, const std::vector<size_t> &offsets, size_t phase_ref_offset = 0, const std::string &start_tag = "corr_est");
    };

  } // namespace hamnet70
} // namespace gr

#endif /* INCLUDED_HAMNET70_CORRECT_FREQUENCY_FROM_PILOT_SYMS_H */

